/*-----------------------------------------------------------------
LOG
    GEM - Graphics Environment for Multimedia

    A cube

    Copyright (c) 1997-1998 Mark Danks. mdanks@cybermed,ucsd.edu
    For information on usage and redistribution, and for a DISCLAIMER OF ALL
    WARRANTIES, see the file, "GEM.LICENSE.TERMS" in this distribution.

-----------------------------------------------------------------*/

#ifndef INCLUDE_CUBE_H_
#define INCLUDE_CUBE_H_

#include "Base/GemShape.h"

/*-----------------------------------------------------------------
-------------------------------------------------------------------
CLASS
    cube
    
    Creates a cube

KEYWORDS
    geo

DESCRIPTION
    
-----------------------------------------------------------------*/
class GEM_EXTERN cube : public GemShape
{
    CPPEXTERN_HEADER(cube, GemShape)

    public:

	    //////////
	    // Constructor
    	cube(t_floatarg size);
    	
    protected:
    	
    	//////////
    	// Destructor
    	virtual ~cube();

    	//////////
    	// Do the rendering
    	virtual void 	render(GemState *state);

    	//////////
    	// How the object should be drawn
    	virtual void	typeMess(t_symbol *type);
};

#endif	// for header file
